Subject: Re: [PATCH] Xilinx UART Lite 2.6.18 driver

From: "David H. Lynch Jr." <[email-masked]>
Date: Fri, 13 Oct 2006 02:48:14 -0400

David Bolcsfoldi wrote:
> No I did not know that unfortunately, it could have saved me some work.
> You are of course right and I'd much prefer to make changes to your driver
> instead of writing another one.
>   
    I am sorry you put so much effort in. However, you could have 
checked the archives.
    I think there are atleast 3 different UartLite drivers posted since 
January.

    It would be really nice if we could all standardize on one driver.
    But I would not sweat this too much.
    Peter ignored the fact that my driver was posted here in January, 
too and went off and wrote his own
    which does not have early serial port - yours and mine do.
    and does not have polled support - mine does.
    and does not have DCR support - there is another one out there that 
has DCR support.
    and I can not get to work on my hardware - the only Xilinx V4 based 
product that actually defaults to a UartLite
> I've noticed that in the probe function it tries to get some resources
> from the platform_device structure but it looks like that this
> operation will always fail unless I add a 'uartlite' platform device
> or have I completely misunderstood how platform devices work?
>   
    Peter's driver uses the IORESOURCE requests to pull platform data.
    Most other serial platformdevices pull a uart_port object.
    My limited understanding of IORESOURCE is that it is not 
sufficiently deep to support
    the parameters that are needed to support UartLite such as a DCR 
flag and a regoffset.

    Counting yours that is 4.

> But yes, I will try to add support for the things I need to this
> driver instead, most importantly early console support and move the
> #defines for register offsets and such into a separate header file per
> Grants comments
>   
    You are welcome to do that. I already patched his driver to work 
with my early console support as well as adding the boot-bash stuff
    similar to yours. But I gave up actually using it when I could not 
get it to work.

    Next time I get an opportunity I am going to try to setup an ml403 
to atleast verify that Peter's driver is working there.

> Cheers,
> David
>
> On 10/12/06, Peter Korsgaard <[email-masked]> wrote:
>   
>>>>>>> "David" == David Bolcsfoldi <[email-masked]> writes:
>>>>>>>               
>> Hi David,
>>
>> David> here's a set of patches that adds support for Xilinx UART lite
>> David> devices. It has been tested on an ML403-FX using xapp902
>> David> (ml403_ppc_plb_temac) using a 2.6.18 kernel and a BusyBox
>> David> userspace.
>>
>> I guess you didn't know, but there already exists a uartlite driver!
>> It unfortunately didn't made it into 2.6.19-rc1 because Russell
>> stopped maintaining serial stuff, but it's in -mm.
>>
>> It also has an official lanana.org assigned set of device nodes.
>>
>> I didn't look at your patch yet, but I think it would be more useful
>> to add any features missing to my driver than writing yet another
>> driver (I think we're up to 3 now).
>>
>> --
>> Bye, Peter Korsgaard
>> _______________________________________________
>> Linuxppc-embedded mailing list
>> [email-masked]
>> https://ozlabs.org/mailman/listinfo/linuxppc-embedded
>>
>>     
> _______________________________________________
> Linuxppc-embedded mailing list
> [email-masked]
> https://ozlabs.org/mailman/listinfo/linuxppc-embedded
>   

-- 
Dave Lynch 					  	    DLA Systems
Software Development:  				         Embedded Linux
717.627.3770 	       [email-masked] 	  http://www.dlasys.net
fax: 1.253.369.9244 			           Cell: 1.717.587.7774
Over 25 years' experience in platforms, languages, and technologies too numerous to list.

"Any intelligent fool can make things bigger and more complex... It takes a touch of genius - and a lot of courage to move in the opposite direction."
Albert Einstein